/**
 * hacky plugin to allow removal of the jquery tools tooltip objects.
 *
 * Doesn't pay any attention to the special event configuration, and will blindly unbind all
 * mouse[enter|leave] listeners from the trigger element.
 *
 * https://gist.github.com/854708
 */
(function($){
    var tooltip = $.fn.tooltip,
        slice = Array.prototype.slice;

    function removeTooltip($elements){
        $elements.each(function(){
            var $element = $(this),
                api = $element.data("tooltip"),
                tip ;
            if( api ){
                api.hide();
                tip = api.getTip();
                if( tip ){
                    tip.remove();
                }
                api.getTrigger().unbind('mouseenter mouseleave');
                $element.removeData('tooltip');
            }
        });
    }

    $.fn.tooltip = function(p){
        if( p === 'remove'){
            removeTooltip(this);
            return this;
        } else {
            return tooltip.apply(this, slice.call(arguments,0));
        }
    }
})(jQuery);