$(document).ready(airInitialise);

var language = null;
var labels = {};
var newsFeed ;

function airInitialise() {
    initialiseWindow({
        close:onCloseWindow
    });
	newsFeed = startupWindow().newsFeed;
	initialise();
}

function onCloseWindow() {
	nativeWindow.close();
}

function errorloader(XMLHttpRequest, textStatus, errorThrown) {
	alert("Error");
	showerror();
}

function initialise(){
	setupLanguage(getELSParam("moLanguage"), continueInit);
}

function continueInit() {
	setLabelText();
	populateNews();
}

function setLabelText() {
    // options panel
    $("#title").html(labels.news.header);
}

function populateNews() {
	var $newsContent = $('#newsContent');	
	var first = true;
	newsFeed.items(function(item){
		if( first ){
			$newsContent.html('');
			first = false;
		}
		var article = $('<div>',{'class':'article'}),
			enclosure = item.enclosure();
		if(!item.read){
			article.addClass('new-article');
		}
		// title with link 
		article.append($('<a>',{'href':item.link()})				
						.append($('<h2/>').text(item.title()))
				);
		// image if present
		if( enclosure && enclosure.type.indexOf('image') > -1){
			article.append($('<img>',{src:enclosure.url}));
		}

		// pub date + description
		article.append($('<span>',{'class':'pubDate'}).text(item.pubDate()));
		article.append($('<p>').html(item.description()));
		
		article.appendTo($newsContent);
		
		item.markRead();
	});
}
