$(document).ready(airInitialise);

var language = null;

function airInitialise() {
    initialiseWindow({
        close:onCloseWindow
    });
	initialise();
}

function onCloseWindow() {
	optionsWindow.hide();
}

function errorloader(XMLHttpRequest, textStatus, errorThrown) {
	alert("Error");
	showerror();
//	$("#errorcontainer .tryagain").button();
}

function showOptions() {
	var options = new air.NativeWindowInitOptions(); 
	options.transparent = true; 
	options.systemChrome = "none"; 
	options.type = "lightweight"; 
	options.resizable = false;
	options.maximizable = false;
	 
	var windowBounds = new air.Rectangle(10,10,300,400); 
	newHTMLLoader = air.HTMLLoader.createRootWindow(true, options, true, windowBounds); 
	newHTMLLoader.load(new air.URLRequest("options.html"))
}


//var w, h;
var requiredLanguage;
var moListStyle;
var moDays;
var moFSSI;
var moLocation = null;
var moColourScheme;
var moMapDisplay;
var moMapsRequired;
var moTemperatureUnits;
var moSpeedUnits = "M";
var moShowWind;
var moShowUV;
var moShowFeelsLike;
var moAllowUserLocation;
var labels = {};


function initialise(){
	setupLanguage(getELSParam("moLanguage"), continueInit);
	requiredLanguage = getELSParam("moLanguage");
}

function continueInit() {
    setLabelText();
    setNecessaryStyling();	 // this is exceptional styling that has to be set dynamically rather than in CSS.
    setupOptions();
    $("body *").attr("dir", labels.language.direction).attr("lang", labels.language.code);
    $("#componentCSS").remove();
    
    var headID = document.getElementsByTagName("head")[0];         
    var cssNode = document.createElement('link');
    cssNode.type = 'text/css';
    cssNode.rel = 'stylesheet';
    cssNode.href = 'component' + labels.language.direction + '.css';
    cssNode.media = 'screen';
	cssNode.id = "componentCSS";
    headID.appendChild(cssNode);			
}

function setLabelText() {
    // options panel
    $("#title").html(labels.options.header);
    $("#resetOptions").html(labels.options.reset);
    $("#optionsSave").html(labels.options.save);
    $("#optionsCancel").html(labels.options.cancel);
    $("#optionsForecastSelectionCancelContents").html(labels.options.cancel);
    $("#optionsLocationSearchContents").html(labels.options.search);
	$("#optionsLocationMessage").html(labels.options.location);
	$("#optionsForecastSelectionPanelMessage").html(labels.options.locationselect);
    $("#optionsLanguageMessage").html(labels.options.language);
    $("#optionsUnitsTemperatureMessage").html(labels.options.temperature);
    $("#optionsUnitsWindMessage").html(labels.options.windSpeed);
    $("#optionsUnitsDisplayMessage").html(labels.options.displayOptions);
    
    $("#optionsTemperatureMessageF").html(labels.units.Fahrenheit);
    $("#optionsTemperatureMessageC").html(labels.units.Celsius);
   
    $("#optionsWindSpeedMessageM").html(labels.units.MilesPerHour);
    $("#optionsWindSpeedMessageK").html(labels.units.KilometresPerHour);
    $("#optionsWindSpeedMessageN").html(labels.units.Knots);

    $("#optionsShowMapMessage").html(labels.options.maps);
    $("#optionsShowWindMessage").html(labels.options.wind);
    $("#optionsShowUVMessage").html(labels.options.uv);
    $("#optionsShowFeelsLikeMessage").html(labels.options.feelsLike);
    $("#optionsLanguageMessage").html(labels.options.language);
}

function setNecessaryStyling() {
	// setting the height helps styling in FF on corners.  
   	$("#optionsLocationSearch").button();
   	$("#optionsSave").button();
   	$("#optionsCancel").button();
   	$("#optionsForecastSelectionCancel").button();
	$("#optionsForecastSelectionPanel").width(nativeWindow.width - 30);
	$("#optionsLocation").width(nativeWindow.width - 30);
}

function setupOptions() {
	$("#optionsTemperature" + getELSParam("moTemperatureUnits")).attr("checked", "checked");
	$("#optionsSpeedUnits" + getELSParam("moSpeedUnits")).attr("checked", "checked");
	
	if (getELSParam("moMapDisplay") == "true") {
		$("#optionsShowMap").attr("checked", "checked");
	}
	if (getELSParam("moShowWind") == "true") {
		$("#optionsShowWind").attr("checked", "checked");
	}
	if (getELSParam("moShowUV") == "true") {
		$("#optionsShowUV").attr("checked", "checked");
	}
	if (getELSParam("moShowFeelsLike") == "true") {
		$("#optionsShowFeelsLike").attr("checked", "checked");
	}

    if (air.NativeApplication.supportsStartAtLogin ){
        $('#optionsStartAtLoginRow').show();
        $('#optionsStartAtLogin').attr("checked",localOptions.boolean('shouldStartAtLogin',true));
    }

    var location = currentLocation.get();
	$("#optionsLocation").data("location", location);
	$("#optionsLocation").val(internationalPlace(location.getName()));
//	$("#optionsLocation").val(location.getName());
	
	if(networkMonitor.available()){
		$("#optionsLocation").removeAttr("disabled"); 
		$("#optionsLocationErrorContent").hide();
	}else{
		$("#optionsLocation").attr("disabled", "disabled"); 
		$("#optionsLocationErrorMessage").html("Can not change location whilst disconnected");
		$("#optionsLocationErrorImage").attr("src", "/lib/icons/icon_alert.gif");
		$("#optionsLocationErrorContent").show();
	}
	
	$("#optionsLocation").locsearch(doSelection, true, false, true, false, settings.rootDataUrl);
 
    $("#optionsCancel").click(cancelOptions);
    $('#resetOptions').css("color", "white").css("position","relative").css("left", "25px").css("top","10px").click(resetOptions);

	$("#optionsForecastSelectionCancel").click(resetSelectionPanel);
    $("#optionsSave").unbind("click").click(saveOptions);
    /*$("#optionsLanguage option").remove();
	$.ajax({url: "/lib/data/language/languages.txt", 
		method: "GET",
		dataType: "json",
		async: false,
		success: function(data) {
            for (var i = 0; i < data.length; i++) {
                $("<option>").attr("value", data[i].code).html(data[i].name).appendTo("#optionsLanguage");
            }
            $("#optionsLanguage option[value=" + requiredLanguage + "]").attr("selected", "selected");
		},
        failure: function() {
            alert(labels.error.langLoadProblem+": " + language);
        },
		timeout: 15000, 
        cache: true
	});*/
}

function cancelOptions() {
	optionsWindow.hide();
}

function resetOptions() {
	air.EncryptedLocalStore.reset();
	currentLocation.reset();
	air.NativeApplication.nativeApplication.dispatchEvent(new air.Event("optionsChanged"));	
	optionsWindow.hide();
}

function doSelection(obj,event) {
 if( event ) event.preventDefault();

	$("#optionsForecastSelectionPanel").fadeIn();
    $('#optionsButtons button').button('disable');
    $('#optionsForecastSelectionPanelMessage').after("<img class='loader' src='/lib/images/ajaxLoaderSmall.gif'/>");
    var start = Date.now();
	metoffice.location.getNNearest({
			point:new metoffice.point({lat:obj.l,lon:obj.g}),
			quantity:5,
			observationsOnly:false,
			success: function(locslist, processingTime){
				log("getNNearest: ", (Date.now() - start), processingTime);
 
				$('#optionsForecastSelectionPanel img.loader').remove();
                $("#optionsForecastSelectionPanel ul").html("");
					$.each(locslist,function(){
					var loc = this.location;
						$("<li>").text(internationalPlace(loc.getName()) + " (" + Math.floor(this.dist * 10) / 10 + labels.units.mi+")")
//						$("<li>").text(loc.getName() + " (" + Math.floor(this.dist * 10) / 10 + labels.units.mi+")")
						.click(function() {
							$("#optionsLocation").data("location", loc);
							resetSelectionPanel();
						})
						.hover(function(){ $(this).addClass("hover");},function() {$(this).removeClass("hover");})
						.appendTo("#optionsForecastSelectionPanel ul");
					});
				},
            error:function(error){
            	resetSelectionPanel();
            	alert(labels.options.nNearestError);
			}
	});

}

function resetSelectionPanel() {
	$("#optionsForecastSelectionPanel").fadeOut();
	$("#optionsForecastSelectionPanel li").html("");
    var location = $("#optionsLocation").data("location");
	$("#optionsLocation").val(internationalPlace(location.getName()));
    $('#optionsButtons button').button('enable');
    $('#optionsForecastSelectionPanel img.loader').remove();
}

function saveOptions() {
    //var requiredLanguage = $("#optionsLanguage option:selected").val();
    var requiredLanguage = "en";
	var temperatureUnits = $("input[name=optionsTemperature]:checked").val();
	var speedUnits = $("input[name=optionsWindSpeed]:checked").val();
	
	var showMap = $("input[name=optionsShowMap]").prop("checked");
	var showWind = $("input[name=optionsShowWind]").prop("checked");
	var showUV = $("input[name=optionsShowUV]").prop("checked");
	var showFeelsLike = $("input[name=optionsShowFeelsLike]").prop("checked");    
	
	var location = $("#optionsLocation").data("location");

	if (location !== null) {
        info("setting current location");
		currentLocation.set(location);
	}
	setELSParam("moLanguage", requiredLanguage);
	setELSParam("moTemperatureUnits", temperatureUnits);
	setELSParam("moSpeedUnits", speedUnits);
	setELSParam("moMapDisplay", showMap);
	setELSParam("moShowWind", showWind);
	setELSParam("moShowUV", showUV);
	setELSParam("moShowFeelsLike", showFeelsLike);

    if( air.NativeApplication.supportsStartAtLogin ){
        localOptions.set("shouldStartAtLogin", !!$('#optionsStartAtLogin').attr('checked'));
        try{
        	air.NativeApplication.nativeApplication.startAtLogin = !!$('#optionsStartAtLogin').attr('checked');
        }
        catch(error){
        	
        }
    }

	air.NativeApplication.nativeApplication.dispatchEvent(new air.Event("optionsChanged"));	
	optionsWindow.hide();
}

