
$(function(){
    initialiseWindow({
        close:onCloseWindow
    });
    $('button').button();

    $('#install').click(startDownload);
    $('#status .progress').progressbar();

    setupLanguage(getELSParam("moLanguage"), function() {

        $('.availableVersion').html(updater.latestUpdate.version.versionText);
        $('.currentVersion').html(updater.getApplicationVersion().versionText);
        $('#releaseNotes').html(updater.latestUpdate.note);
    });
});

function onCloseWindow() {
    updater.cancelDownload();
    updateWindow.hide();
    log("update.onCloseWindows");
}

function startDownload(){

    var $progress = $('#status .progress'),
        $message = $('#status .message');

	$('#install').button('disable');

    $progress.progressbar('value',0).show();
    $message.html('Downloading update');
    $('#releaseNotesHolder').fadeOut(function(){
        $('#status').fadeIn();
    });

	updater.startDownload({
		updatingStatus:function(e){
            var percentage = Math.round((e.bytesLoaded / e.bytesTotal) * 100);
            $progress.progressbar('value', percentage);
        },
        complete:function(){
            $progress.progressbar('value', 100);
            $message.html("Launching installer");
            updater.installUpdate();
        },
		onError:function(msg){
            $message.html(msg);
            $progress.fadeOut();
            $('#install').button('enable');
        }
	});

}